import Geometry
from Vector import Vector, Vectortype, dot, length
import weakref
import Numeric
class CollisionDone(Exception):
    """Thrown to indicate that the collision has been handled. Means: don't bounce, I took care of it."""
    pass


class PhysicsController:
    def __init__(self, game):
        self.game = game
        self.on = False #Start in non-physicated state
        self.affects_dict = weakref.WeakKeyDictionary()
        

    def thread(self):
        while True:
            if self.game.paused: yield None
            else:
                for obj, pattern in self.game.patterns.items():
                    try:
                        pattern.next()
                    except StopIteration:
                        del self.game.patterns[obj]
                for i, a in enumerate(self.game.actions):
                    try:
                        a.next()
                    except StopIteration:
                        del self.game.actions[i]

                self.game.geometry.collide_all(self.game)
                self.game.forces.clear()
                for obj, body in self.game.geometry.bodies.items():
                    if body.getPosition()[2] != 0:
                        print obj, "z position", body.getPosition()[2]

                yield None

